#include <algorithm>
#include <cctype>
#include <string>

using std::find_if;
using std::string;

using std::isspace;

inline bool mezera(char c)
{
	return isspace(c);
}

inline bool neni_mezera(char c)
{
	return !isspace(c);
}

template <class Vystup> 							// zmnno
void rozdeleni(const string& str, Vystup vp) {		// zmnno

	typedef string::const_iterator iter;

	iter i = str.begin();
	while (i != str.end()) {
		// ignoruje poten przdn znaky
		i = find_if(i, str.end(), neni_mezera);

		// nalezne konec dalho slova
		iter j = find_if(i, str.end(), mezera);

		// kopruje znaky v rozsahu '[i,' 'j)'
		if (i != str.end())
			*vp++ = string(i, j);	// zmnno

		i = j;
	}
}

