// Tento soubor obsahuje pouze ukzky implementac vybranch algoritm
// standardn knihovny. Nen pouit dnm jinm kdem knihy.

template <class Vstup, class X> Vstup find(Vstup zacatek, Vstup konec, const X& x)
{
	while (zacatek != konec && *zacatek != x)
		++zacatek;
	return zacatek;
}

template <class Vstup, class Vystup>
Vystup copy(Vstup zacatek, Vstup konec, Vystup cil)
{
	while (zacatek != konec)
		*cil++ = *zacatek++;
	return cil;
}

template <class Dopredu, class X>
void replace(Dopredu zacatek, Dopredu konec, const X& x, const X& y)
{
	while (zacatek != konec) {
		if (*zacatek == x)
			*zacatek = y;
		++zacatek;
	}
}

template <class Obousmer> void reverse(Obousmer zacatek, Obousmer konec)
{
	while (zacatek != konec) {
		--konec;
		if (zacatek != konec)
			swap(*zacatek++, *konec);
	}
}

template <class Nah, class X>
bool binary_search(Nah zacatek, Nah konec, const X& x)
{
	while (zacatek < konec) {
		// nalezne prostedek rozsahu
		Nah pros = zacatek + (konec - zacatek) / 2;

		// podv se, kter st rozsahu obsahuje 'x'; dle hled pouze v t sti
		if (x < *pros)
			konec = pros;
		else if (*pros < x)
			zacatek = pros + 1;
		// pokud jsme se dostali a sem, potom '*pros == x' a meme skonit
		else return true;
	}
	return false;
}

